(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1997-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: og_misc.mli,v 1.3 2014/01/31 09:51:52 fclement Exp $ *)

exception Fatal_error;;
val fatal_error: string -> 'a;;

val hash_table_make: int -> ('a * 'b) list -> ('a, 'b) Hashtbl.t
(** Make a hash table of the given size and fills it with the
    given bindings. *)

val array_map_to_list : ('a -> 'b) -> 'a array -> 'b list;;
(** Map a function to the lements of a vector and retruns the list of
  results. *)

val string_first_char : string -> char;;
(* [string_first_char s] return the first character of string [s].
   Raise [invalid_argument "first_char"] if [s] is empty. *)

val list_map_end : ('a -> 'b) -> 'a list -> 'b list -> 'b list
;;

val iter_sep : ('a -> unit) -> ('a -> unit) -> 'a list -> unit
;;
